//-*-c++-*------------------------------------------------------------
//
// File name : bioArithElementaryExpression.cc
// Author :    Michel Bierlaire
// Date :      Sat Apr 16 14:28:39 2011
//
//--------------------------------------------------------------------

#include "patDisplay.h"
#include "bioArithElementaryExpression.h"
#include "patErrNullPointer.h"

bioArithElementaryExpression::bioArithElementaryExpression(bioExpressionRepository* rep,
							   patULong par) :
  bioExpression(rep,par) {

}

bioArithElementaryExpression::~bioArithElementaryExpression() {

}

patString bioArithElementaryExpression::getExpression(patError*& err) const {
  return  getOperatorName() ;
}

patULong bioArithElementaryExpression::getNumberOfOperations() const {
  return 0 ;
}


void bioArithElementaryExpression::forceCodeGeneration() {
  codeMustBeGenerated = patTRUE ;
}

patBoolean bioArithElementaryExpression::containsAnIterator() const {
  return patFALSE ;
}

patBoolean bioArithElementaryExpression::containsAnIntegral() const {
  return patFALSE ;
}

patBoolean bioArithElementaryExpression::containsASequence() const {
  return patFALSE ;
}

bioExpression* bioArithElementaryExpression::getExpressionFromId(patULong theId) {
  if (theId == getId()) {
    return this ;
  }
  return NULL ;
}

void bioArithElementaryExpression::simplifyZeros(patError*& err) {
  return ;
}

void bioArithElementaryExpression::generateGslFunctions(ostream& str_h,patString prefix,patError*& err) {
  return ;
}

patString bioArithElementaryExpression::getIncludeStatements(patString prefix) const {
  return patString() ;
}

void bioArithElementaryExpression::setVariables(const patVariables* x) {
  __x = x ;
}

void bioArithElementaryExpression::setDraws(const vector<vector< patReal > >* d) {
  __draws = d ;
}

patBoolean bioArithElementaryExpression::isSimple() const {
  return patTRUE ;
}

void bioArithElementaryExpression::setSample(const bioSample* s) {
  theSample = s ;
}

void bioArithElementaryExpression::setCurrentSpan(bioIteratorSpan aSpan) {
  theCurrentSpan = aSpan ;
}

void bioArithElementaryExpression::setThreadSpan(bioIteratorSpan aSpan) {
  theThreadSpan = aSpan ;
}

void bioArithElementaryExpression::collectExpressionIds(set<patULong>* s) const {
  s->insert(getId()) ;
}



patString bioArithElementaryExpression::check(patError*& err) const {
  return patString() ;
}
