//-*-c++-*------------------------------------------------------------
//
// File name : bioConstraintWrapper.cc
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Sun Oct 25 09:44:55 2009
//
//--------------------------------------------------------------------

#include "bioConstraintWrapper.h"


bioConstraintWrapper::bioConstraintWrapper() : trFunction() {

}

bioConstraintWrapper::~bioConstraintWrapper() {

}


patReal bioConstraintWrapper::getFunction(trVector* x,
					  patBoolean* success,
					  patError*& err) {
  err = new patErrMiscError("This function should never be called. It must be overloaded") ;
  WARNING(err->describe()) ;
  return patReal() ;
}

trVector* bioConstraintWrapper::getGradient(trVector* x,
					    trVector* grad,
					    patBoolean* success,
					    patError*& err) {
  err = new patErrMiscError("This function should never be called. It must be overloaded") ;
  WARNING(err->describe()) ;
  return NULL ;

}
  
patReal bioConstraintWrapper::getFunctionAndGradient(trVector* x,
						     trVector* grad,
						     patBoolean* success,
						     patError*& err) {
  err = new patErrMiscError("This function should never be called. It must be overloaded") ;
  WARNING(err->describe()) ;
  return patReal() ;
}


trHessian* bioConstraintWrapper::computeHessian(patVariables* x,
						trHessian& hessian,
						patBoolean* success,
						patError*& err) {
  computeFinDiffHessian(x, hessian,success, err)  ;
  if (err != NULL) {
    WARNING(err->describe()) ;
    *success = patFALSE ;
    return NULL ;
  }
  *success = patTRUE ;
  return &hessian ;

}
 

trHessian* bioConstraintWrapper::getCheapHessian(trVector* x,
						 trHessian& hessian,
						 patBoolean* success,
						 patError*& err) {
  return NULL ;
}

patBoolean bioConstraintWrapper::isCheapHessianAvailable() {
  return patFALSE ;
}

trVector bioConstraintWrapper::getHessianTimesVector(trVector* x,
						     const trVector* v,
						     patBoolean* success,
						     patError*& err) {
  return trVector() ;
}

patBoolean bioConstraintWrapper::isGradientAvailable(patError*& err) 
  const {
  err = new patErrMiscError("This function should never be called. It must be overloaded") ;
  WARNING(err->describe()) ;
  return patFALSE ;

}

patBoolean bioConstraintWrapper::isHessianAvailable(patError*& err) const {
  return patTRUE ;
}

patBoolean bioConstraintWrapper::isHessianTimesVectorAvailable(patError*& err) const {
  return patFALSE ;
}

void bioConstraintWrapper::generateCppCode(ostream& str, patError*& err) {
  return ;
}

