//-*-c++-*------------------------------------------------------------
//
// File name : bioModel.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Mon Apr 27 15:41:49 2009
//
//--------------------------------------------------------------------

#ifndef bioModel_h
#define bioModel_h

#include "bioExpression.h"
#include <map>
/*!
Class defining a model in the general sense. 
*/

class bioArithPrint ;

class bioModel {

public:
  bioModel();
  void setFormula(patULong theFormula) ;
  void setExcludeExpr(patULong excludeExpr) ;
  void setWeightExpr(patULong weightExpr) ;
  void setStatistics(map<patString, patULong>* stat) ;
  void setConstraints(map<patString, patULong>* constr) ;
  void setSimulation(bioArithPrint* simul) ;
  void setRepository(bioExpressionRepository* rep) ;
  patULong getFormula() ;
  patULong getExcludeExpr() ;
  patULong getWeightExpr() ;
  map<patString, patULong>* getStatistics() ;
  map<patString, patULong>* getConstraints() ;
  bioArithPrint* getSimulation() ;

  patBoolean mustEstimate() const ;
  patBoolean mustSimulate() const ;

  bioExpressionRepository* getRepository() ;
protected:
  patULong theFormula ;
  map<patString, patULong>* statistics ;
  map<patString, patULong>* constraints ;
  bioArithPrint* simulation ;
  patULong excludeExpr ;
  patULong weightExpr ;
  bioExpressionRepository* theRepository ;

};


#endif
