//-*-c++-*------------------------------------------------------------
//
// File name : patZeroOneAntithetic.h
// Author :    \URL[Michel Bierlaire]{http://roso.epfl.ch/mbi}
// Date :      Sun Jun 13 11:09:27 2010
//
//--------------------------------------------------------------------

#ifndef patZeroOneAntithetic_h
#define patZeroOneAntithetic_h



/**
   @doc Generate pseudo-random numbers from a unifrom distribution [0:1].
 */

#include <fstream>
#include "patType.h"
#include "patRandomNumberGenerator.h"
class patError ;
class patUniform ;

class patZeroOneAntithetic : public patRandomNumberGenerator {

 public:
  /**
   */
  patZeroOneAntithetic(patULong R, 
		       patULong s, 
		       patBoolean dumpDrawsOnFile,
		       patError*& err) ;
  /**
   */
  virtual ~patZeroOneAntithetic() ;
  /**
   */
  void setUniform(patUniform* rng) ;

  /**
   */
  virtual patReal getNextValue(patError*& err) ;

  /**
   */
  virtual patReal getZeroOneDraw(patError*& err) ;
  virtual patBoolean isSymmetric() const ;

private:
  void generate(patError*& err) ;

 private:
  patUniform* uniformNumberGenerator ;
  ofstream* logFile ;
  patReal zeroOneDraw ;
  patULong nbrOfDraws ;
  patULong nbrOfSeries ;
  vector< vector<patReal> > theDraws ;
  patBoolean first ;
  patULong currentValue ;
  patULong currentSerie ;
};
#endif
